//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "main.h"
#include <stdio.h>
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TMainForm *MainForm;
AnsiString prolog,epilog;

unsigned char buf[16*64];// 1024
unsigned char buf_out[((16*5)+3)*64 + 100];
//---------------------------------------------------------------------------
__fastcall TMainForm::TMainForm(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Button1Click(TObject *Sender)
{
if(!OD->Execute()) return;
eInputFile->Text = OD->FileName;
eStructName->Text = ChangeFileExt(ExtractFileName(OD->FileName),"");
TDateTime dt;
eComment->Text = "// Make " + DateTimeToStr(dt.CurrentDateTime());
eArrayAttribute->Text = "const static unsigned char ";
eOutputFile->Text = ChangeFileExt(OD->FileName,".c");

EnableControl(100);

eInputFile->Color = clWindow;
eStructName->Color = clWindow;
eComment->Color = clWindow;
eArrayAttribute->Color = clWindow;
btnMake->Enabled = true;

UpdateHeader();
}
//---------------------------------------------------------------------------
long filesize(FILE *stream)
{
   long curpos, length;

   curpos = ftell(stream);
   fseek(stream, 0L, SEEK_END);
   length = ftell(stream);
   fseek(stream, curpos, SEEK_SET);
   return length;

}
//---------------------------------------------------------------------------
void __fastcall TMainForm::UpdateHeader()
{
unsigned char buf[100] = {0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15};
memset(buf,0,100);
size_t fsize = 0;
if(!eInputFile->Text.IsEmpty())
	{
  FILE *fin = fopen(eInputFile->Text.c_str(),"rb+");
	if(fin != NULL) fsize = filesize(fin);
  fclose(fin);
  }
prolog = eComment->Text +  + "\r\n";
prolog += "#define A_" + eStructName->Text.UpperCase() + "_SIZE " + IntToStr(fsize) + "\r\n";
prolog += eArrayAttribute->Text + " a_" + eStructName->Text + "[A_" + eStructName->Text.UpperCase() + "_SIZE] = {\r\n  ";
char *pbuf = buf;
if(cbHex->Checked)
	{
  for(int i=0;i<15;i++) pbuf += sprintf(pbuf,"0x%02X,",i);
	sprintf(pbuf,"0x%02X",16);
  }else
	{
  for(int i=0;i<15;i++) pbuf += sprintf(pbuf,"%d,",i);
	sprintf(pbuf,"%d",16);
  }
AnsiString aaa = (AnsiString)(char*)buf;
epilog = "\r\n\  };// end of array a_" + eStructName->Text  + "\r\n";

mPreview->Clear();
AnsiString tstr = prolog + aaa + epilog;
mPreview->Text = tstr;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::btnMakeClick(TObject *Sender)
{
FILE *fin = fopen(eInputFile->Text.c_str(),"rb+");
if(fin == NULL)
	{
  ShowMessage("Can't open input file...");
  return;
  }
long fsize = filesize(fin);
if(fsize == 0)
	{
  ShowMessage("Input file is zero size...");
  fclose(fin);
  return;
  }

FILE *fout = fopen(eOutputFile->Text.c_str(),"wb+");
if(fin == NULL)
	{
  ShowMessage("Can't open output file...");
  fclose(fin);
  return;
  }

AnsiString aaa;
size_t cnt = 0;

fwrite(prolog.c_str(),prolog.Length(),1,fout);

pb->Min = 0;
pb->Max = fsize/16;
pb->Visible = true;
Refresh();
while(!feof(fin))
	{
  cnt = fread(buf,1,16,fin);
  if(cnt)
  	{
    fsize -= cnt;
  	char *pbuf = buf_out;
  	memset(buf_out,0,1024);
    aaa = "";
  	for(unsigned long i=0; i<cnt-1; i++)
    	{
      if(cbHex->Checked) pbuf += sprintf(pbuf,"0x%02x,",buf[i]);
      else if(cbDec->Checked) pbuf += sprintf(pbuf,"%d,",buf[i]);
      }
  	if(cbHex->Checked) pbuf += sprintf(pbuf,"0x%02x",buf[cnt-1]);
    else if(cbDec->Checked) pbuf += sprintf(pbuf,"%d",buf[cnt-1]);
  	if(fsize)
  		sprintf(pbuf,",\r\n  ");
  	fwrite(buf_out,strlen(buf_out),1,fout);
  	pb->Position++;
    pb->Refresh();
    }
  }
fwrite(epilog.c_str(),epilog.Length(),1,fout);

fclose(fout);
fclose(fin);

pb->Visible = false;
Refresh();

Beep();
ShowMessage("FINISH WORK...");
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::DisableControl(int tag)
{
TComponent *cmp;
for(int i=0;i<ComponentCount;i++)
    {
    cmp = Components[i];
    if(cmp->Tag == tag)
        if(dynamic_cast<TControl *>(cmp) != NULL)
            ((TControl*)cmp)->Enabled = false;
        if(dynamic_cast<TEdit *>(cmp) != NULL)
            ((TEdit*)cmp)->Color = clBtnFace;
    }
};
//---------------------------------------------------------------------------
void __fastcall TMainForm::EnableControl(int tag)
{
TComponent *cmp;
for(int i=0;i<ComponentCount;i++)
    {
    cmp = Components[i];
    if(cmp->Tag == tag)
        if(dynamic_cast<TControl *>(cmp) != NULL)
            ((TControl*)cmp)->Enabled = true;
        if(dynamic_cast<TEdit *>(cmp) != NULL)
            ((TEdit*)cmp)->Color = clWhite;
    }
};
//---------------------------------------------------------------------------
void __fastcall TMainForm::eUpdatePreview(TObject *Sender)
{
UpdateHeader();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FormCreate(TObject *Sender)
{
DisableControl(100);
UpdateHeader();
}
//---------------------------------------------------------------------------

